// /////////////////////////////////////////////////////////////////////////
// SystemC code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#ifndef LFSR_APB_WRAPPER_HH
#define LFSR_APB_WRAPPER_HH

#include <stdint.h>
#include <systemc>

class lfsr_apb_wrapper :
    public sc_core::sc_module
{

public:

    sc_core::sc_in< bool > pclk;
    sc_core::sc_in< bool > presetn;
    sc_core::sc_in< uint32_t > paddr;
    sc_core::sc_in< bool > psel;
    sc_core::sc_in< bool > penable;
    sc_core::sc_in< bool > pwrite;
    sc_core::sc_in< uint32_t > pwdata;
    sc_core::sc_out< bool > pready;
    sc_core::sc_out< uint32_t > prdata;
    uint32_t prdata_var_0;
    uint8_t prdata_partial0;
    sc_core::sc_signal< uint8_t > out_partial_sig;
    uint8_t old_out_partial_sig;
    uint8_t out_partial_sig_sig_var;
    bool lfsr_0_linear_feedback;

    void hif_cone_lfsr_0_linear_feedback();


    void hif_cone_prdata_partial0();


    void hif_cone_out_partial_sig();



    SC_HAS_PROCESS( lfsr_apb_wrapper );

    lfsr_apb_wrapper( sc_core::sc_module_name name_ );
    ~lfsr_apb_wrapper();


private:

    lfsr_apb_wrapper( const lfsr_apb_wrapper & );
    const lfsr_apb_wrapper& operator= ( const lfsr_apb_wrapper & );


    void lfsr_0_process();
    void globact_process();

};


#endif

